<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";

import { useRouter } from "vue-router";
import { checkPermission } from "@/utils/permissions";
import { useTransferDataStore } from "@/modules/05_placement/store";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

/** importType*/
import type { QTableProps } from "quasar";
import type { listMain } from "@/modules/05_placement/interface/response/OhterMain";

/** importcomopnents*/
import Dialogbody from "@/modules/05_placement/components/Other/DialogOrders.vue";

/** use*/
const $q = useQuasar();
const router = useRouter();
const storeFn = useTransferDataStore();
const { statusText } = storeFn;
const {
  showLoader,
  hideLoader,
  success,
  messageError,
  date2Thai,
  dialogRemove,
} = useCounterMixin();

const modal = ref<boolean>(false);

/**
 * Table
 */
const rows = ref<listMain[]>([]); //รายการอื่นๆ
const rows2 = ref<listMain[]>([]); //รายการออกคำสั่ง
const filterKeyword = ref<string>(""); //คำค้นหารายการอื่นๆ
const filterKeyword2 = ref<string>(""); //คำค้นหารายการออกคำสั่ง
const visibleColumns = ref<string[]>([
  "no",
  "fullname",
  "positionLevel",
  "organizationPositionOld",
  "createdAt",
  "status",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "fullname",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "fullname",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return `${row.prefix === null ? "" : row.prefix}${row.firstName} ${
        row.lastName
      }`;
    },
  },
  {
    name: "positionLevel",
    align: "left",
    label: "ประเภทตำแหน่ง",
    sortable: true,
    field: "positionLevel",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      let name = "";
      if (row.positionTypeOld && row.positionLevelOld) {
        name = `${row.positionTypeOld} (${row.positionLevelOld})`;
      } else if (row.positionTypeOld) {
        name = `${row.positionTypeOld}`;
      } else if (row.positionLevelOld) {
        name = `(${row.positionLevelOld})`;
      } else name = "-";
      return name;
    },
  },
  {
    name: "organizationPositionOld",
    align: "left",
    label: "ตำแหน่ง/สังกัดเดิม",
    sortable: true,
    field: "organizationPositionOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่ดำเนินการ",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) => date2Thai(val),
  },
  {
    name: "status",
    align: "left",
    label: "สถานะ",
    sortable: true,
    field: "status",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) => statusText(val),
  },
]);
const pagination = ref({
  sortBy: "createdAt",
  descending: true,
  page: 1,
  rowsPerPage: 10,
});

/**
 * fetch รายการอื่นๆ
 */
async function fecthlistOthet() {
  showLoader();
  await http
    .get(config.API.otherMain())
    .then((res) => {
      let response = res.data.result;
      rows.value = response;
      // หารายชื่อส่งไปออกคำสั่งอื่นๆ
      rows2.value = rows.value.filter(
        (e: listMain) =>
          e.status !== "REPORT" &&
          e.status !== "DONE" &&
          e.organizationPositionOld &&
          e.positionTypeOld &&
          e.positionLevelOld &&
          e.positionNumberOld &&
          e.positionDate &&
          e.leaveDate !== null
      );
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * เปิด popup ส่งไปออกคำสั่งอื่นๆ
 */
function popup() {
  modal.value = true;
  filterKeyword2.value = "";
}

/**
 * ปิด popup ส่งไปออกคำสั่งอื่นๆ
 */
function clickClose() {
  modal.value = false;
}

/**
 * ยืนยันการลบรายการอื่นๆ
 * @param id รายการอื่นๆ
 */
function clickDelete(id: string) {
  dialogRemove($q, () => {
    showLoader();
    http
      .delete(config.API.otherByid(id))
      .then(async () => {
        await fecthlistOthet();
        await success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * redialect รายละเอียดรายการอื่นๆ
 * @param id รายการอื่นๆ
 */
function nextPage(id: string) {
  router.push({
    path: `/placement/other/detail/${id}`,
  });
}

onMounted(() => {
  fecthlistOthet();
});
</script>
<template>
  <div class="toptitle text-dark col-12 row items-center">รายการอื่นๆ</div>
  <q-card flat bordered class="col-12 q-mt-sm">
    <div class="row q-pa-md">
      <div class="col-12">
        <div class="row col-12">
          <q-btn
            v-if="checkPermission($route)?.attrIsUpdate"
            @click="popup()"
            size="14px"
            flat
            round
            color="add"
            icon="mdi-account-arrow-right"
          >
            <q-tooltip>ส่งไปออกคำสั่งรายการอื่นๆ</q-tooltip>
          </q-btn>
          <q-space />
          <q-input
            class="col-xs-12 col-sm-3 col-md-2"
            standout
            dense
            v-model="filterKeyword"
            ref="filterRef"
            outlined
            debounce="300"
            placeholder="ค้นหา"
          >
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>
          <q-select
            v-model="visibleColumns"
            multiple
            outlined
            dense
            options-dense
            :display-value="$q.lang.table.columns"
            emit-value
            map-options
            :options="columns"
            option-value="name"
            style="min-width: 140px"
            class="col-xs-12 col-sm-3 col-md-2 q-ml-sm"
          />
        </div>

        <div class="col-12 q-pt-sm">
          <d-table
            :columns="columns"
            :rows="rows"
            :filter="filterKeyword"
            row-key="id"
            :visible-columns="visibleColumns"
            v-model:pagination="pagination"
          >
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th auto-width />
                <q-th v-for="col in props.cols" :key="col.name" :props="props">
                  <span class="text-weight-medium">{{ col.label }}</span>
                </q-th>
              </q-tr>
            </template>
            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td auto-width>
                  <q-btn
                    v-if="checkPermission($route)?.attrIsGet"
                    flat
                    round
                    dense
                    icon="mdi-eye"
                    color="info"
                    @click.stop.prevent="nextPage(props.row.id)"
                  >
                    <q-tooltip>รายละเอียด</q-tooltip>
                  </q-btn>

                  <q-btn
                    v-if="checkPermission($route)?.attrIsDelete"
                    flat
                    :disable="
                      props.row.status == 'REPORT' || props.row.status == 'DONE'
                    "
                    round
                    dense
                    :color="
                      props.row.status == 'REPORT' || props.row.status == 'DONE'
                        ? 'grey-5'
                        : 'red'
                    "
                    icon="mdi-delete"
                    @click.stop="clickDelete(props.row.id)"
                  >
                    <q-tooltip>ลบข้อมูล</q-tooltip>
                  </q-btn>
                </q-td>
                <q-td v-for="col in props.cols" :key="col.id">
                  <div v-if="col.name === 'no'">
                    {{ props.rowIndex + 1 }}
                  </div>

                  <div
                    v-else
                    :class="
                      col.name === 'organizationPositionOld' ||
                      col.name === 'organization'
                        ? 'table_ellipsis2'
                        : ''
                    "
                  >
                    {{ col.value ? col.value : "-" }}
                  </div>
                </q-td>
              </q-tr>
            </template>
          </d-table>
        </div>
      </div>
    </div>
  </q-card>

  <Dialogbody
    v-model:Modal="modal"
    v-model:filter-keyword2="filterKeyword2"
    :click-close="clickClose"
    :rows2="rows2"
    :fecthlistOthet="fecthlistOthet"
  />
</template>

<style scoped lang="scss"></style>
